Loading...
Searching...
No Matches
Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl Class Reference
Inheritance diagram for Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl:
[legend]
Collaboration diagram for Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl:
[legend]

## Public Member Functions

| AprImpl (AbcA::CompoundPropertyReaderPtr iParent, Ogawa::IGroupPtr iGroup, PropertyHeaderPtr iHeader)
virtual const AbcA::PropertyHeader & | getHeader () const
virtual AbcA::ObjectReaderPtr | getObject ()
virtual AbcA::CompoundPropertyReaderPtr | getParent ()
virtual AbcA::ArrayPropertyReaderPtr | asArrayPtr ()
virtual size_t | getNumSamples ()
virtual bool | isConstant ()
virtual void | getSample (index_t iSampleIndex, AbcA::ArraySamplePtr &oSample)
virtual std::pair< index_t, chrono_t > | getFloorIndex (chrono_t iTime)
virtual std::pair< index_t, chrono_t > | getCeilIndex (chrono_t iTime)
virtual std::pair< index_t, chrono_t > | getNearIndex (chrono_t iTime)
virtual bool | getKey (index_t iSampleIndex, AbcA::ArraySampleKey &oKey)
virtual void | getDimensions (index_t iSampleIndex, Alembic::Util::Dimensions &oDim)
virtual bool | isScalarLike ()
virtual void | getAs (index_t iSample, void *iIntoLocation, Alembic::Util::PlainOldDataType iPod)
Public Member Functions inherited from Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::ArrayPropertyReader
virtual | ~ArrayPropertyReader ()
virtual void | getSample (index_t iSampleIndex, ArraySamplePtr &oSample)=0
virtual std::pair< index_t, chrono_t > | getFloorIndex (chrono_t iTime)=0
virtual std::pair< index_t, chrono_t > | getCeilIndex (chrono_t iTime)=0
virtual std::pair< index_t, chrono_t > | getNearIndex (chrono_t iTime)=0
virtual bool | getKey (index_t iSampleIndex, ArraySampleKey &oKey)=0
| Expose the key for apps that use their own custom cache management.
virtual void | getDimensions (index_t iSampleIndex, Dimensions &oDim)=0
virtual void | getAs (index_t iSample, void *iIntoLocation, PlainOldDataType iPod)=0
Public Member Functions inherited from Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::BasePropertyReader
virtual | ~BasePropertyReader ()
const std::string & | getName () const
PropertyType | getPropertyType () const
bool | isScalar () const
bool | isArray () const
bool | isCompound () const
bool | isSimple () const
const MetaData & | getMetaData () const
const DataType & | getDataType () const
TimeSamplingPtr | getTimeSampling () const
virtual ScalarPropertyReaderPtr | asScalarPtr ()
virtual CompoundPropertyReaderPtr | asCompoundPtr ()

## Member Function Documentation

## asArrayPtr()

AbcA::ArrayPropertyReaderPtr Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::asArrayPtr | ( |  | ) |

virtual

Up-cast this base property to an ArrayProperty, if such an upcast is valid. This can be checked with the isArray() function. If the upcast is not valid, an empty pointer will be returned. This default implementation returns an empty pointer.

Reimplemented from Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::BasePropertyReader.

## getHeader()

const AbcA::PropertyHeader & Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::getHeader | ( |  | ) | const

virtual

Properties are created with a collection of metadata that is stored in a lightweight structure called PropertyHeader. This returns a constant reference to the PropertyHeader which was given upon creation.

Implements Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::BasePropertyReader.

## getNumSamples()

size_t Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::getNumSamples | ( |  | ) |

virtual

Return the number of samples contained in the property. This can be any number, including zero. This returns the number of samples that were written, independently of whether or not they were constant. Implementations may (and should) choose to condense identical samples.

Implements Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::ArrayPropertyReader.

## getObject()

AbcA::ObjectReaderPtr Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::getObject | ( |  | ) |

virtual

All properties have an object that owns them, and in order to ensure the object stays alive as long as the properties do, they retain a shared pointer to their object.

Implements Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::BasePropertyReader.

## getParent()

AbcA::CompoundPropertyReaderPtr Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::getParent | ( |  | ) |

virtual

Most properties live in a compound property. (Except for the top-compound property in any object) This returns a pointer to the parent compound property.

Implements Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::BasePropertyReader.

## isConstant()

bool Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::isConstant | ( |  | ) |

virtual

Ask if we're constant - no change in value amongst samples, regardless of the time sampling.

Implements Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::ArrayPropertyReader.

## isScalarLike()

bool Alembic::AbcCoreOgawa::ALEMBIC_VERSION_NS::AprImpl::isScalarLike | ( |  | ) |

virtual

A hint about whether this property has 1 and only 1 DataType for each of it's samples. Array Properties with no samples written to it are still considered scalar like.

Implements Alembic::AbcCoreAbstract::ALEMBIC_VERSION_NS::ArrayPropertyReader.

The documentation for this class was generated from the following files:

- AbcCoreOgawa/AprImpl.h
- AbcCoreOgawa/AprImpl.cpp